# $Date: 1996/09/19 08:47:03 $ $Author: frankp $ $Revision: 1.3 $ #

#--
	abs/rectform -- the function attribut "rectform" for abs
--#

abs := funcattr( abs, "rectform", proc(x)
	name abs::rectform;
        local a, b, rl;
    begin
        if args(0) = 2 then
            x := rectform::new(x,args(2))
        else
            x := rectform::new(x)
        end_if;
        rl := extop(x,4);
        if extop(x,3) <> 0 then
            new(rectform,0,0,hold(abs)(rectform::expr(x)),rl)
        else
            a := extop(x,1);
            b := extop(x,2);
            if domtype(a+I*b) = DOM_COMPLEX
               and (domtype(a) = DOM_FLOAT or domtype(b) = DOM_FLOAT)
            then rectform::new(abs(a+I*b))
            elif sign(a+I*b) = 0 or sign(a+I*b) = 1 then
                new(rectform,a+I*b,0,0,rl)
            elif iszero(a) or iszero(b) then
                new(rectform,abs(a+I*b),0,0,rl)
            else
                new(rectform,sqrt(a^2+b^2),0,0,rl)
            end_if
        end_if
    end_proc
):

# end of file #
